% Generacja wspczynnikw filtrw IIR do kolorofonu
% Plik wykonywalny w programie Matlab
% Rafa Baranowski (C) 2005

clc; clf; clear;

SR=8000;    % czstotliwo prbkowania [Hz]
SR2=SR/2;   % poowa czstotliwoci prbkowania [Hz]

% obliczanie wspczynnikw IIR B i A wg prototypw Chebyshev'a I rodzaju
[Bl,Al]=cheby1(2,1.5,200/SR2)          % dla filtru LPF: 2 rz., R=1.5 dB, fg=200 Hz
[Bm,Am]=cheby1(2,1.5,[500, 1000]/SR2)  % dla filtru BPF: 4 rz., R=1.5 dB, fg1=0.5 kHz, fg2=1 kHz
[Bh,Ah]=cheby1(2,1.5,2000/SR2, 'high') % dla filtru HPF: 2 rz., R=1.5 dB, fg=2 kHz

% obliczanie zespolonej odpowiedzi czstotliwociowej filtrw IIR
[Fl,fl]=freqz(Bl,Al,256,SR);  % dla filtru LPF
[Fm,fm]=freqz(Bm,Am,256,SR);  % dla filtru BPF
[Fh,fh]=freqz(Bh,Ah,256,SR);  % dla filtru HPF

% obliczanie charakterystyki amplitudowej filtrw IIR
Fl=abs(Fl);  % dla filtru LPF
Fm=abs(Fm);  % dla filtru BPF
Fh=abs(Fh);  % dla filtru HPF

% wywietlanie charakterystyki amplitudowej zaprojektowanych filtrw
plot(fl,Fl,'k-.', fm,Fm,'k-', fh,Fh,'k:');
legend('Kanal dolnoprzepustowy', 'Kanal srodkowoprzepustowy', 'Kanal gornoprzepustowy');
xlabel('f [Hz]');
ylabel('czulosc');