; Tester pilotw SIRC
; Rafa Baranowski (C) 2005

.INCLUDE "tn26def.inc"		; SEGMENT DEKLARACJI

.EQU OSC_FREQ	= 1000000	; czstotliwo pracy w Hz
.EQU SYS_FREQ	= OSC_FREQ/1000000; czstotliwo pracy w MHz
					; stae odbiornika podczerwieni
.EQU K_IR_IN	= DDRB	;   rejestr kierunku portu
.EQU O_IR_IN	= PORTB	;   rejestr wyjciowy portu
.EQU I_IR_IN	= PINB	;   rejestr wejciowy portu
.EQU IR_IN		= 6		;   nr linii dla sygnau odbieranego (INT0)
					; stae wywietlacza LCD
.EQU K_LCD		= DDRB	;   rejestr kierunku portu
.EQU O_LCD		= PORTB	;   rejestr wyjciowy portu
.EQU LCD_DB4	= 0		;   nr linii dla sygnau DB4
.EQU LCD_DB5	= 1		;   nr linii dla sygnau DB5
.EQU LCD_DB6	= 2		;   nr linii dla sygnau DB6
.EQU LCD_DB7	= 3		;   nr linii dla sygnau DB7
.EQU LCD_RS		= 4		;   nr linii dla sygnau RS
.EQU LCD_EN		= 5		;   nr linii dla sygnau EN


.DSEG					; SEGMENT DANYCH
.ORG	0x0060			; pocztek pamici SRAM
IR_rozkaz:		.BYTE 1	;   zmienna rozkazu wiadomoci SIRC
IR_adres:		.BYTE 1	;   zmienna adresu wiadomoci SIRC
IR_znacz:		.BYTE 1	;   zmienna znacznikw wiadomoci SIRC


.CSEG					; SEGMENT PROGRAMU
.ORG	0				; wektor zerowania
	rjmp	Reset			; skok do procedury inicjalizujcej
.ORG	INT0addr			; wektor przerwania INT0
	rjmp	Odbior_IR		; skok do procedury obsugujcej odbiornik podczerwieni

.ORG	0x30				; przejcie do pierwszej komrki za wektorami przerwa


Reset:				; podprogram inicjalizujcy
	ldi	R16, RAMEND
	out	SP, R16		; inicjalizacja wskanika stosu

	rcall	Ini_IR		; inicjalizacja odbiornika podczerwieni
	rcall	Ini_LCD		; inicjalizacja wywietlacza LCD

	sei				; odblokuj przerwania


Petla:
	lds	R16, IR_znacz
	sbrs	R16, IR_nowy
	rjmp	Petla			; oczekuj na odbir nowej wiadomoci

	cbr	R16, 1<<IR_NOWY
	sts	IR_znacz, R16	; wyzeruj znacznik nowej wiadomoci

	rcall	Czysc_LCD		; wyczy wywietlacz
	ldi	R16, 'R'
	rcall	Zapisz_LCD		; wywietl prefiks rozkazu ("R")
	lds	R16, IR_rozkaz
	rcall	Pokaz_bajt_LCD	; wywietl kod rozkazu wiadomoci

	ldi	R16, 1
	rcall	Spacja_LCD		; wprowad odstp

	ldi	R16, 'A'
	rcall	Zapisz_LCD		; wywietl prefiks adresu ("A")
	lds	R16, IR_adres
	rcall	Pokaz_bajt_LCD	; wywietl adres wiadomoci

	rjmp	Petla			; zaptl program


					; DOCZANE PODPROGRAMY
.INCLUDE "czekaj_ms.inc"	;   oczekiwanie milisekundowe
.INCLUDE "czekaj_us.inc"	;   oczekiwanie mikrosekundowe
.INCLUDE "ir_sirc.inc"		;   obsuga odbiornika podczerwieni
.INCLUDE "lcd.inc"		;   obsuga wywietlacza LCD
